<?php

namespace 1111\1111\Policies;

use App\User;
use Illuminate\Auth\Access\HandlesAuthorization;
use 1111\1111\Models\1111;

class 1111Policy
{
    use HandlesAuthorization;

    /**
     * Determine if the given user can view the 1111.
     *
     * @param User $user
     * @param 1111 $1111
     *
     * @return bool
     */
    public function view(User $user, 1111 $1111)
    {
        if ($user->canDo('1111.1111.view') && $user->is('admin')) {
            return true;
        }

        return $user->id === $1111->user_id;
    }

    /**
     * Determine if the given user can create a 1111.
     *
     * @param User $user
     * @param 1111 $1111
     *
     * @return bool
     */
    public function create(User $user)
    {
        return  $user->canDo('1111.1111.create');
    }

    /**
     * Determine if the given user can update the given 1111.
     *
     * @param User $user
     * @param 1111 $1111
     *
     * @return bool
     */
    public function update(User $user, 1111 $1111)
    {
        if ($user->canDo('1111.1111.update') && $user->is('admin')) {
            return true;
        }

        return $user->id === $1111->user_id;
    }

    /**
     * Determine if the given user can delete the given 1111.
     *
     * @param User $user
     * @param 1111 $1111
     *
     * @return bool
     */
    public function delete(User $user, 1111 $1111)
    {
        if ($user->canDo('1111.1111.delete') && $user->is('admin')) {
            return true;
        }

        return $user->id === $1111->user_id;
    }

    /**
     * Determine if the user can perform a given action ve.
     *
     * @param [type] $user    [description]
     * @param [type] $ability [description]
     *
     * @return [type] [description]
     */
    public function before($user, $ability)
    {
        if ($user->isSuperUser()) {
            return true;
        }
    }
}
