<?php

namespace 1111\1111\Repositories\Eloquent;

use 1111\1111\Interfaces\1111RepositoryInterface;
use Litepie\Database\Eloquent\BaseRepository;

class 1111Repository extends BaseRepository implements 1111RepositoryInterface
{
    /**
     * @var array
     */
    protected $fieldSearchable = [
        'name'  => 'like'
    ];

    public function boot()
    {
        $this->pushCriteria(app('Litepie\Database\Criteria\RequestCriteria'));
    }

    /**
     * Specify Model class name.
     *
     * @return string
     */
    public function model()
    {
        return config('package.1111.1111.model');
    }
}
